--デモ用に、JH101_001から201の300個のデータを内蔵し、独立して動くようにした Sep25,2022
--  この時、使用済みデータのグローバルデータへの保存、pronの機能は殺した
-- バグ検証　repeat時短機能　2度目フラグの停止後復活させると止まる。再度停止すれば動く
--101Words2022 HomePageからDLできるサンプルプログラム(Sep19,2022)
-- AnyWordV12 のpron開発向けspin out: Repeat(英単語のみ読上げ)、pron(単語認識結果記録)Mar4 2018
-- グローバルデータの表示、消去、コピー機能追加。
-- プルダウンリストの最下段の表示を固定する2018.4.26
-- speakTimeEの測定 mode=1 に限定
--supportedOrientations(PORTRAIT)
function setup()
    pronFlg=false
    testSw=false  --開発中の新ルーチンのテスト on/off    
    debugFlg= false -- ディバグ用フラグ ,本番はOpening以外はnoButtonスクリーンになる。
    breakBtnFlg=true  
if debugFlg==true then viewer.mode=OVERLAY end
--[[
概要:AnyWord     オープニングで、パラメタ機能を利用して、単語、モードを切り替える  
7/20---
    オープニング画面の最適化 AAsw: trueでAA機能を有効にする
                    パラメタ状態のフィードバックをわかりやすく表示
    バグとり確認 
    list    レ rectModeをcenterに戻す
    Repeat  反応は甘いが、とりあえずOk
            measureSpeed()    作動せず   止めた
            2度読み停止は反応が甘いが作動
                ボタン判定領域が重複？  はしていない
                読み上げ、2度読みの両方を止めることはok しかし、pause,rew等を押すとリセットされてしまう。
            レ masterボタンのタイミング確認
            レ pauseボタンのチャット？ 原因不明だが消えた
            レ rew,forwardの確認
    compete レ 解答提示後のみOk有効:stage2のみ黒文字、タッチ有効、TouchXをクリア
            レ okボタンが小さい rect: 80x80  ellipse: r=90
            レ 新問題で提示時にリセット
    spell  レ タイムアップのリンギング排除。次問に自動送り:
            レ 無入力防止とタイムアップの競合。タイムアップ時には" "を自動挿入で解決

    
    opening sfX, sfYを使って、位置のユニバーサル化完了
    list rectの位置、モードが崩れる editorにも波及 
        repeatでrectMode: radious としたため、Repeat直後のルーチンでサイズが倍になる。さらにrectModeのdefaultはcornerのため、rectModeをcenter としたルーチンと競合した。repeatの条件をcenterにした。
    
7/20
    spell 連続実施の場合、scoreがリセットされない
    スコアは上がるが、出題は続く。ただし、ランダムモードになっている。
    スコアが4で頭打ち
    残問がマイナスになることもあり
 
---    

-- v14 work の開発項目 6/6作成
    -- 1 オープニングのタッチへの反応トロさの解消--パラメタの利用. ok 6/20
    --     ただし、fullScreenモードで rect、ellipseのサイズが倍、mode center/CORNERのtrip等の不安定あり
    -- 2 AAのオーバーライドオプション パラメタ処理 doAllFlg==true
    --   全モードでeditを可能にし、Score=AAにする。
    
----Anyword v12(Jan2018)
        レ 入試、中学、英検、独自単語に対応
        レ 初回正解の場合激励語(10種)、連続すると新語を出す  
        レ spellの正誤判定で、eng付属の記号を無視(~など)
----Anyword prontest(v12+)
    レ 全パラメータの設定保存、再現
    レ repeat: 英語のみ発音(録音用) 発話間隔は発音待受時間で設定
    pron(新設) 認識結果の記録 ファイル名 FN＋pron  Id#word#recong#
------
v20へ向けて  
------
50単語を単位とする。
クリップボードを介した、新単語bookの登録。独自リストのクリップボードへの吸上げ。
単語book選択:データリストの表示とリストからの選択。(upgradeで、リスト表示範囲を拡大)
Listモード、50単語スクロール表示。
speech.rateのクロック同期：発話スピードの実時間保証
発話による、進行の抑制(言い終わるまで、次に行かない)
Spellモード：word,imiデータの正誤判定で自動的に無視する記号の登録機能  〜(連)(文)など

]]
    aaCount=0
Program="101AnyWord 0.9" -- May7 2017 --May26. Jun4 July20
fType="101words_"
fName="101words"
--    fType:データタイプ(101word, JH101...)
--    fName:ファイルネーム fType .. グループ番号.."01"
--    fFile: ファイルのパス "Documents:"..fName,  FFileは"Dropbox:".. fName
--=============================   

    tickTestFlg=false
    clearGlobalDataFlg=false
    initFlg=false
--=========    

--    print("check globalData")
        fileTbl=listGlobalData()
    for i,v in ipairs (fileTbl) do
if debugFlg==true then  print("GlobalData",v) end
        if clearGlobalDataFlg==true then
  --          print  ("erase:",v)           
            saveGlobalData(v,nil)  
        end
    end
 --プロジェクトのアイコン
--myImage = readImage("Dropbox:V20")
--saveImage( "Project:Icon", myImage )    
   tickX=0
    sstickX=""  
---------
 sfX=WIDTH/768
sfY=HEIGHT/1028   
fnt=sfX
---------
    cx=200*sfX
    cy=500*sfY
gcX=WIDTH/2
gcY=HEIGHT/2
width0=WIDTH
doIniFlg=true
    mark={}   
    touchedIni()
    getDataIni()
    openingIni()  
    JHdataIni()
stage=-1 
fName=""
tx=0
ty=0  
    EngSpeed=0.5 -- 英語は標準スピード
    JpnSpeed=0.6  -- 日本語は少し早口
    skip2rep=false
    editFlg=false
    editEFlg=false
    editJFlg=false   
    exListFlg=false
    submitEJFlg=False
     k=0
    parmSetFlg=false
  
    kbFlg=false
    ssValue=""
strWpS=""
ssTick=""   
kk=0  
--NN=100  -- Nnumber of data
    NN=50
NP=math.ceil(NN/25)-- number of pages in review
for i=1,100 do
    mark[i]=0
end    
ipage=1 
pauseFlg=false
startTime=0
pronFileID="pron"..os.time()
end  -- end of setup()

---=======================================
function draw()
  background(4, 4, 4, 255)
tickCtrl()
if breakBtnFlg then breakBtn() end -- レビュー用停止ボタン
if WIDTH~=width0 then      
--      sound("Dropbox:Block 3")
        ss="Width:"..width0.." -> "..WIDTH..". elapsed time"..ElapsedTime
        textSize(20*fnt)
        fill(255, 29, 0, 255)
        text(ss,gcX*1.8,gcY*1.95)
        width0=WIDTH
 end
-- stage:-1 opening(モードと単語を設定)
if stage==-1 then 
--        openingIni()
        opening3()  
    
end
    
--stage:0 実行用初期設定(データ設定、モード別初期設定)
    
if stage==0 then
    if fName~="" then   
--[[ 一度使用したデータをグローバルデータに保存する機能は殺した
--chech if there is the GlobalData 
            gData=readGlobalData(fName)   
            if gData~=nil then  
    -- devide the Global file into tables
                makeTbls()   
                if mode==3 then Score=Score3 end
                if mode==4 then Score=Score4 end
                if mode==5 then Score=Score5 end               
            else  
    -- without GlobalData, make tables from Documents text file       
               getData()         
            end 
 ]]
         getData()     
        if doIniFlg==true then
            doIniFlg=false
            if mode==1 or mode==2 then
                Repeat:init(x)              
            end
            if mode==3  or mode==4 then
                Compete:init(x)              
            end    
            if mode==5 then
                Spell:init(x)              
            end    
            if mode==6 then
                Pron:init(x)              
            end    
                
        end                   
    end
--[[
end  --end of stage:0


if stage==0 then
]]
    Ri=Ri0
--ランダム化は見送り----------
-- if noExempt > NN/2 then rnd=true end  -- 出題数が少ない(<50)なら自動的にランダム順
    NQ=NN-noExempt
 RemQ=NQ     

    setQ()   
    if gotoListFlg==true then
        stage=9
    else
        stage=1
        newQ()
    end
end

if stage>0 and stage<9 then
        if mode==1 or mode==2 then
            Repeat:draw()
        end
        if mode==3 or mode==4 then
            Compete:draw()
        end
        if mode==5 then
            Spell:draw()          
        end
        if  mode==6 and pronFlg then
            Pron:draw()          
        end                
end
    
if stage==9 then
        review()  -- review the list  

end
if stage==10 then -- start new session
       saveJsonDataGlobal()           
        fontSize(fnt*40)
        fill(83, 134, 227, 254)
        ss="Let's start a new session"
        text(ss,WIDTH/2,150*sfY)  
        speakEng(ss)
           stage=-1
        openingIni()             
end  
if stage==18 then
    listFiles()     
    end
if stage==20 then
    closeSession() 
end

end -- End of draw

function speakEng(ss)
 if ss=="" then 
       sound(SOUND_JUMP, 11987)
        return
 end
-- play reorded voice if wordAlt contavins "mp3"
    isMp3=string.find(ss,".mp3")
    if isMp3~=nil then 
            Mp3File="Dropbox:"..string.sub(ss,1,isMp3-1)
            music(Mp3File)
        return
    else 
-- normal TTS
    speech.rate=EngSpeed
   speech.language="en-US"
-- trap to detect double read. aaCount is set as 0  @ main.5
--    aa={"1","2","3","4","5","-"}
--aaCount=aaCount+1
--aa0=assert(tonumber(aa[aaCount])) --文字は数値に変換出来ないことを利用してエラーを誘い、エラーメッセージからここを呼んでいる箇所を見つける
--print("aa0",aa0)
-----------
    speech.say(ss)       
    end
end

function speakJpn(ss)
 if ss=="" then 
        sound(SOUND_JUMP, 11987)
        return
 end
    speech.rate=JpnSpeed
    speech.language="ja-JP"
        speech.say(ss)
end


function newQ()
::NQ::    
        stage=1
        Ri=Ri+1
if mode==1 then -- 処理速度の判定は、今後一般機能に拡張するが、当面はmode1のみで実施
  --   measureSpeed()    
    end
        if Ri>NN+Ri0  then
        stage=9
        goto eoNQ
        end
 --print("Qno[Ri]", Qno[Ri])   
   Qi=Qno[Ri]
if mode==1 then -- 処理速度の判定は、今後一般機能に拡張するが、当面はmode1のみで実施

   if Score[Qi]  > 0 then goto NQ end-- skip when Score=1
    RemQ=RemQ-1
end
        speakE=true
        speakJ=true
    speakFlg=true
        timer1=pause
        timer2=wait   
::eoNQ::
end

function measureSpeed()
-- measure word per sec
        tGame1=os.time()         
        tWord=os.difftime(tGame1,tGame0)
        wps=tWord/Ri       
        strWpS=string.format("%f",wps)
    strWpS=string.sub(strWpS,1,5).."w/s"       
end



function textboxEng()
cxE=cx
if mode==2 or mode==4 then cxE=cx+400*sfX end -- display Eng on the right in mode~=1    
    fill(0, 255, 8, 255)
 --   font("Vegur")
    fontSize(fnt*50)  
       if string.len(word)  >10 then
           fontSize(fnt*40)   
    end 
    textWrapWidth(gcX*0.8)    
    text(word,cxE,cy)   
   textWrapWidth(WIDTH)    
end
function textboxJpn()
cxJ=cx+400*sfX
if mode==2 or mode==4 then cxJ=cx end -- display Eng on the right in mode~=1    
    fill(209, 209, 70, 225) 
 --   font("Vegur")
    fontSize(fnt*45)  
    textWrapWidth(gcX*0.8)    
    if string.len(imi) >20 then
        i=string.find(imi,"；")
            if i==nil then 
                i=string.find(imi,"（")
                if i~=nil then i=i-3 end
            end
            if i==nil then i=string.find(imi," 【") 
                 if i~=nil then i=i-3 end               
            end
            if i==nil then i=string.find(imi,"、") end  
        if i~=nil and i>0  then         
            imiA=string.sub(imi,1,i-1)
            imiB=string.sub(imi,i+3)           
            text(imiA,cxJ,cy-10*sfY) 
            fontSize(fnt*35)             
            text(imiB,cxJ,cy-80*sfY)    
        else
            fontSize(fnt*30)  
            text(imi,cxJ,cy-10*sfY)    
        end
    else
        text(imi,cxJ,cy-10*sfY)  
    end 
   textWrapWidth(WIDTH)    
end
function textboxNum()
     fill(0, 200, 255, 255)
    font("ArialRoundedMTBold")
    fontSize(fnt*20)   
 --   sID=str(ii) 
    text(id[ii],cx+200*sfX,cyy+85*sfY)   
end

function tickCtrl() 
-- initialze:  tickX=0,t1X=os.time(),sstickX="",debugFlg
    tickX=tickX+1
    t2X=os.time()
    if t2X~=t1X then
        if tickX~=0 then tick=1/tickX end
--        print("time, tick,  tick/sec", t1X,tickX,tickXCount)
        sstickX=string.format("%u",tickX).." cycle/sec"
        t1X=t2X
        tickX=0
    end
        fontSize(fnt*15)
        fill(142, 33, 31, 255)
 if tickTestFlg==true then  text(sstickX,gcX*0.3,gcY*1.95)  end   
end

function breakBtn()
fontSize(30)
fill(236, 79, 67)
text("☜",gcX*0.1,gcY*0.05)   
ifTouched(gcX*0.1 ,gcY*0.05)
if TouchedFlg then
    TouchedFlg=False
        close()
    end
end
function breakBtnAlt()
--KB表示でbreakBtnを左下に表示できない場合上中央に表示する
fontSize(30)
fill(236, 79, 67)
text("☜",gcX,gcY*1.85)   
ifTouched(gcX ,gcY*1.85)
if TouchedFlg then
TouchedFlg=False
close()
end
end

function closeSession()
    if closeSessionFlg==true then
         closeSessionFlg=false
       saveJsonDataGlobal()           
        ss="End of the session"
         tt=os.difftime(tEnd,t1)   
        speakEng(ss)
        sstt=string.format("%u",tt)
        strtt="Total duration is "..sstt.." sec."
    end
        fontSize(fnt*40)
        fill(83, 134, 227, 254)
        text(ss,WIDTH/2,gcY) 
        text(strtt, WIDTH/2, gcY*0.9) 
    if os.time()>tEnd+2 then
        close()
    end
end








