--[[
開発ノート  12/2
リピートとリストの統合
gotoListFlg=true(パラメタ設定)の場合、リスト表示に直行(stage=9)する
その場合、リスト終了後、resultをかきだして、自動的にリピートモードに進む。
falseなら、リピート、レビューを経過したら終わる

パラメタ
    pause=1 -- pause btw E & J
    parameter.number("wait",2, 5, 4) -- pause for next Q
    parameter.boolean("gotoLisFlg",true) -- まず、レビューから始まる  
    EngSpeed=0.5 -- 英語は標準スピード
    JpnSpeed=0.6  -- 日本語は少し早口
Dec8
  ⚪️  単語リストから単語を選び、編集する。(番号をタップ stage=8で編集)
 ⚪️追加用の番号は、空のデータ入れておく。(MaxはNN個(デフォルト100)) dummyData()
       日本語入力のバグにスリップ、再起動で回復した。
 ★ローマ字入力で時折数字が入れられなくなるが、一旦英文字モードに切り替えれば戻る。
      ⚪️ 英語、日本語エリアをタップして編集開始、確定で抜ける。登録ボタンで抜ける(これでretキーを殺せたので、crlf問題はなくなった)
★★しかし、showKeyboard/hideKeyboardの出入りが不安定で、ハングする。
exListFlg,submiEJFlgでeditorから抜けた後せshowKeyboard()が発動される。showList()側でhideKB()をかけると、次々に呼ばれた時出てこない。
showKeyboard()にkbFlgのラッチをかけたら止まった。
日本語は、一度hideKeyboardをかけてバッファをけし、bufferも消去してから始める
⚪️日本語をBSで2バイト単位で消すと、1バイトのゴミが取れないので残り1バイトのときは""にした。 

⚪️編集が終わったら、1語毎にファイルを更新じ、リストに戻る。
⚪️修正データが共用データを破壊しないよう、修正対象はローカルデータとする。
⚪️ローカルにデータがない時のみ、共用フォルダーからコピーする。

  (未)  編集時に「読み」追加、リストからの除外もオプションとして行う。
    ⚪️リピートリストからの除外も、編集の一環として処理する。

⚪️英語、訳とも読み上げ機能を持たせる
      読み上げルーチンspeak()は最初の文字コードで日英を判定し、言語を切り替える
Dec 9
⚪️ファイル名に&を使うと、データ区切りとコンタミエラーがでた。
v3以降はでデータ区切りに、＄を使う。しかし、最後の回のデータがうまく切り出せない。
OS.timeのゴミか累積する。
➡️ここでResultsを累積する意味はあまりない、resumu機能に絞り、直前回のみを参照することにした。
⚪️🈲ファイル名に"$" は使わない (データ区切りに予約済み  )

⚪️データが空のidはスキップできる
⚪️リストの1番は、 除外されても表示され、読みは日本語始まる、(newQ()をdraw()の頭でよべばよい。Ri=0では始める
⚪️英語発音を、mp3ファイルで補完した。
 補完用ファイルをDropboxにセット。WordsAltのスロットに、(word).mp3をセット。".mp3"が末尾にあるあると、music()でプレイする。遅れは感じない。

⚪️Listの2周目は反応しなくなる。問題カウンタをリセットすればいいのか？ stage0相当の各種初期化をしてからstage1の戻すことで解決
⚪️Alt入力機能の追加12/11
  日英とも入力文字の読み上げ機能で、音を確認する。OKならそのまま登録。
  違和感があれば、読み入力ボタンを押して入力。(文字入力と読み入力を表示、点灯)
  音声ファイルを使うことにした場合"mp3"と入れておく。
  「登録」の都度、データをセーブする。

⚪️❗️sound()が鳴らなくなった。原因不明 やがて回復
⁉️問題番号をパラメタ設定する方式は、うまくセットできていない。
段々遅くなる
nextQ()の後でcollectgarbage()を入れる
セッションタイマーは、saveSession()ではなくstage10でセット

☯️4/8 2017Xcode化に向けた大改修、確認
Editorの機能確認 日本語入力でRetは使わない
日本語は後ろから1字づつ取り扱える
登録時にデータをセーブ

データを選択するオーブ二ングステージを設定、Newで新単語、endでセッション終了
キーボードでなく、独自のテンキーをセットする

,,,,,,,,,,,,,,Xcode
1.メインの文字が小さい --> 
Xcode内で再設定
2.機種でスピードが違いすぎる。iPad2,3は遅過ぎる
tickを機種毎に計り(tick,io.timeを比較)、codeaとXcodeの両方で評価::機種間の差異を吸収する方法を検討する
1秒間のtick数を計り、時間刻み幅tickを(1/秒間のtick数)とすることで機種の違いを調整
ちなみに、drawでの負荷遅れは iPad2/3 27-32秒、iPad-air 57-60秒
3.デバッグモードの導入 debugFlg
4.表示位置のユニバーサル化  sfX(scaling factor for X),sfY, fnt

データ番号をgradeNoにセットし、単語リストをレビューしてからリピートを繰り返す
-- 学習済み単語はレビュー時にリストから除外。学習状況はrNameでグローバルに保存される
-- 新しい単語リストを作るには、存在しないfNameを設定し、入力する。
-- 編集したデータは、グローバルメモリーに保存される。(Xcodeではグローバルメモリはローカルメモリと同じで、そのルーチンしかアクセスできない)
-- 編集したデータは、ドロップボックスにコピーしておく。同期することで共有できる。
-- Editorで日本語入力のときは、Returnを押さずに登録する。returnをおすとCRLFが末尾に入って、リスト行ズレが生じる。
-- 表示位置を汎用化  
    scX,scY (scaling factor of x/y)WIDTH/768, HEIGHT/1028
    fnt (conversion const of font size) =scx fontSize(fnt*nn)
    gcX,gcY(center of global of x in pix) WIDTH/2, HEIGHT/2
--入力データをグローバルデータに切り替える
     (Wordsデータを文字列のままセーブする saveWGlobal(4/27)
    グローバルデータの入出力
  --saveJsonGlobal
    tbl=table.pack(a,b,c)   ss=json.encode(tbl)  saveGlobalData(fName,ss)
  --readJsonGlobal
    ss=readGlobalData(fName)  tbl=json.decode(ss) for i,v in ipairs(tbl) do
    if i==1 then a=tbl[1] end ,,,,
    
----------AllinOne---方針-------------------
OpeningでModeを選択 compete,spell (JtoEに拡張)も含める。
    Mode:   1:Repeat(EtoJ), *2:Repeat(JtoE)
            3:Compeat(EtoJ),*4:Compeat(JtpE)
            5:*Spell(EtoJ)   6:Spell(JtoE)
            7:*pron(EtoJ)   *8:Pron(JtoE)
mode毎にタブを設け、クラス化し、Setup,Drawを分離して走らす

--以下 5/14の残課題    
？？ openingでの ellipsサイズ:2度目は初回の倍になる。以降は変化無し。
    いきなりwidthが768から498になる。133秒後のこともある
    widthが変化しなくてもrectの大きさがふえる(Editルーチン)
👍色々する内にサイズの膨張がなくなってしまった。
👎🏾行間隔、rectの大きさが2かいmで変化するのは未解決

タイミングはos.time(1秒単位)ではなく、システム変数:ElapsedTime でより精密に把握する    
textWrapWidthの無効化はtextWrapWidth(WIDTH)
リストで2度読み(複数箇所でタッチ反応か。タッチルーチンを独立化させる)解消
    オープニングの反応が2度目はトロイ解消
compete okを押すと2度読みになる。一度押すと以降ポイントが継続。
リストのページめくりもダブルで入ってしまう キー毎にifTouchedをいれて解消
out of が0でカウントアップできない
5/19    
markは都度初期化した
Compete 後半の待ちが長い ok,ngボタンで直ちに次単語移るため、timer2=-1<0 で実装
202から始まる。Ri00=0 で解決
    
リストエディットでげーむが始まる。
リストで、英日の読みあげたんごを選択できない。英日の表示、非表示 は選択できる。 
======================================================    
😻リスト大改修  タッチ位置は検出できるが、、ポインターが狂う5/20 ポインターの混同を修正して解決
 👍   原因はライン高さの定数の混同 モード1,3でオープンの行幅がことなるのも同じ

    mode=3で、リストからの単語編集はcompeteに抜けてしまうのを止める、
              リストのendボタンとnewボタンの大きさが半分になる
    --> mode==3のときはパッチを当てて逃げた

    単語はABの50語単位
    改修したが、後半をセットしてもリストは01からしか始まらない。２ページのみ表示
    goしても始まらない 解決 v11  5/23
 Compete/repeat 日->英に着手  101W

モードの追加  Spell Mode:5 spelling  ()6: pron)
新規単語の追加方法  Dropboxから供給されない番号 gr=91-99は独自データ領域

]]
--[[ 
😰残課題 V2.0へ向けて
オープニングは、①単語グループ毎の履歴表示(compE-J,J-E, Spellの成績)、
                グループ、モード選択
初期レビュー画面 
    wordを50個、2列表示。単語毎に３モードの個別スコア表示。scoreA,scireB,scoreC
            タップすると、読み上げとポップで意味表示。(意味もタップ読む)
            スコア4以上はドリルから外す(全単語モードもあり)
    モード、対象オプションをセットしてGo。
    
リストに強制帰還(デバッグ用)ボタン設置(有効の時のみ表示)   
ルーチンの統合化
タッチのチャッチング防止。TouchX=touch.xとし、タッチ判定時にTouchX=0とすることでチャッティングを打ち切る。touch.xを使うと初期化に最低2サイクルかかり、2重読みとなる。
    全てTouchX方式に変更完了
発話中はスピーチキューへの新規登録を止める speakJpn, speakEng をspeech.speakingのときには反応させない。しかし、repeat modeで日本語が止まるので、リストステージの時のみ無効とした。
⭕️ Spell 1分タイマーをつけたが、stage3で表示が消えてしまう。    spellで入力モードを間違えると復帰できない。v12ではSpell機能を外してリリースした。結論はが、stage3の戻りが正しくなかった。修正して解決。
⭕️v10ではopening のタッチが超トロ。tenkeyをキーそれぞれにタッチを判定させたためと判断し、keyBox式に変更。モード、単語一覧の選択画面を作成した(Opening2)が、データがj十分にセットできないので、テンキーの判定方式のみ変更した。
⭕️    Repeatでtimer1の値が途中でnilになった。他のルーチンで同じ名前のグローバル変数を使用しているのがが元凶のよう。独自の変数 timer1Rに変更したら問題解消した。ルーチンをマージンする際のグローバル変数の取り扱いは要注意。
⭕️作業用Scoreへのモードに合わせた過去のScoreの送り込み手順を整えた
    
🛠不明点
 WIDTHが勝手に変わる、rect,ellipseのスケールがmode=3、4,5で変化(縮小)
✍️次の計画
ランダム化は、データを前後に2分割した情況を反映していないためリリースを見送る。
対象データの50個のみシャッフルする方法整理する。
レビューオプションを設け、過去の討ち漏らしや、征服単語を忘れた頃に再出題する機能
次のモードを自動設定し、さらにそれをオーバーライドする復習オプションを設ける
以上 v1.4    

❌変数名にtypeを使ってしまい、エラーが起きた

    ]]  








