function getPrevParameter()

gStr=readGlobalData("Parameter")
if gStr==nil then -- パラメータのデフォルト設定
    mode0=1 
--    fType0="101words"  --対象とする単語系列(独自データも有り)    
    fType0="JH101"
    WordG0=0  --単語グループ(百番代)
    SNo0=true   --開始番号 true:x01~, false:x51~
    AAsw0=true  -- true: AA>=4 で出題停止モード適用
    waitR0=3 -- pause for next Q
    pause0=2 -- pause to answer
    EngS0=5   -- 英語読み上げスピード:速:1-遅:9
    tCutOffPron0=10 --Pronモードでの待受時間（秒）  
else
    tbl=json.decode(gStr)
    for i,v in ipairs(tbl) do
        if i==1 then     mode0=v end
        if i==2 then     fType0=v end  --対象とする単語系列(独自データも有り)    
        if i==3 then     WordG0=v end  --単語グループ(百番代)
        if i==4 then     SNo0=v end   --開始番号 true:x01~, false:x51~
        if i==5 then     AAsw0=v end  -- true: AA>=4 で出題停止モード適用
        if i==6 then     waitR0=v end -- pause for next Q
        if i==7 then     pause0=v end -- pause to answer
        if i==8 then     EngS0=v end   -- 英語読み上げスピード:速:1-遅:9
        if i==9 then     tCutOffPron0=v end --Pronモードでの待受時間（秒）                                                   
    end  
end
end
function listParameter2set()
    parameter.action("スタート", goMain   )    
    parameter.integer("mode", 1,5,mode0,textChanged)
    parameter.text("fType",fType0,textChanged)  --対象とする単語系列(独自データも有り)    
    parameter.integer("WordG",0,2,WordG0,textChanged)  --単語グループ(百番代)
    parameter.boolean("SNo", SNo0,textChanged)   --開始番号 true:x01~, false:x51~
    parameter.boolean("AAsw", AAsw0,textChanged)  -- true: AA>=4 で出題停止モード適用
    parameter.number("waitR",2,5,waitR0,textChanged) -- pause for next Q
    parameter.number("pause",1,3,pause0,textChanged) -- pause to answer
    parameter.integer("EngS", 1,9,EngS0,textChanged)   -- 英語読み上げスピード:速:1-遅:9
    parameter.integer("tCutOffPron",3,20,tCutOffPron0,textChanged) --Pronモードでの待受時間（秒）
 EngSpeed=EngS*0.1
end
function saveParameter()
 tbl=table.pack(mode,fType,WordG,SNo,AAsw,waitR,pause,EngS,tCutOffPron)   
    ss=json.encode(tbl)
    saveGlobalData("Parameter",ss)     
end


